unit timet;

//
// Ԍ`̕ϊT|[g[`W
//
// Copyright (C) 1999 Ayakawa,Marinosuke & MarleySoft
//
// HGD00106@nifty.ne.jp / ayakawa@ac.mbn.or.jp
//
// gpEǁE]ځEzz
//@ ̃jbgɂāAgpE]ځEzz͂RɂȂĂB
// @łA]ځEzzƂ̓A[JCu̍\͕ςȂłˁB
//   OE̘A͂܂B
//   ǂ̂ARɎgpEzzE]ڂĂiĂ邩
//   ǂ͉ǂl̈ӎvłjBÃjbgɂĂ
//   E`͈ɂ́uvƂ͖LĂĂB
//
// 񑩂
// @̃jbgA͉ρEǂꂽjbg̎gpɂAȂ炩
//   ̔QĂҁ@fTisہ@j́AؐӔC𕉂
//   BgpɂȂ̐ӔČɁǍʂ𕉂ĂB
//
// rev 1999/01/18
//     *쐬
// rev 1999/01/19
//     *UTC֘AAZuŏ
//     *DateTimeToDosTimeO𑗏o悤ɕύX
// rev 1999/02/03
//     *DosTimȅ̃~XC(20992079)
// rev 1999/06/06
//     *OoȂo[Wǉ
//

interface

uses
  windows,sysutils;

const
  DT19800101 = 29221.0; // TDateTime1980/01/01
  
type
  // time_t
  PTime_t = ^TTime_t;
  TTime_t = Integer;

// OSFileTime FormatDelphiTDateTimeւ̃Ro[gib΍j
// ԂLocalTimeւ̕ϊ܂Ă̂ŒӂĂˁ`
function FileTimeToDateTime(ft:TFileTime):TDateTime;
function DateTimeToFileTime(dt:TDateTime):TFileTime;
// OȂ
function FileTimeToDateTime2(ft:TFileTime; ADefault:TDateTime):TDateTime;
function DateTimeToFileTime2(dt:TDateTime; ADefault:TFileTime):TFileTime;

// LocalTime|DateTimeݕϊ
function LocalTimeToDateTime(lt:TFileTime):TDateTime;
function DateTimeToLocalTime(dt:TDateTime):TFileTime;

// TimeStampMS-DOS`ɐ؂グ(DelphîƐ؂̂ĂɂȂ)
function DateTimeToDosTime(dt:TDateTime):TDateTime;
function DateTimeToDosTime2(dt:TDateTime; ADefault:TDateTime):TDateTime; // OoȂ

// UTC/FileTime/DateTime Convert
function Time_TtoFileTime(utc:TTime_t):TFileTime; // GST -> GST
function FileTimeToTime_T(ft:TFileTime):TTime_t;  // GST -> GST
function Time_TtoDateTime(utc:TTime_t):TDateTime; // LocalTimeɂĂ܂
function DateTimeToTime_T(dt:TDateTime):TTime_t;  // LocaldtlƉ肵Ă܂

implementation

//
// TFILETIME  ... 1601/01/01 00:00:00N_ 0.1ʕbP
// TTimt_t    ... 1970/01/01 00:00:00N_ 1bP
// TDateTime  ... 1899/12/30 00:00:00N_ ?bP(s)
// TTimeStamp ...    1/01/01 00:00:00N_ P~bP
//

const
  // 1970/01/01TFileTimeŌꍇ
  UTCDelta : TFileTime = ( dwLowDateTime:$D53E8000;
                           dwHighDateTime:$19DB1DE ;);

//
// UTC <-> FILETIME
//
function Time_TtoFILETIME(utc:TTime_t):TFILETIME;
var
  w : TFileTime;
begin
  // result:=utc*10000000+('1601/01/011970/01/01܂ł̍');
  asm
    mov  eax,utc
    mov  ecx,10000000
    mul  ecx                  // 13 clock
    add  eax,$D53E8000
    adc  edx,$19DB1DE
    mov  w.dwLowDateTime,eax
    mov  w.dwHighDateTime,edx
  end;
  result:=w;
end;

function FILETIMEtoTime_T(ft:TFILETIME):TTime_t;
var
  u : TTime_t;
begin
  // 1970/01/01ȑOȂϊłȂ
  IF CompareFileTime(ft,UTCDelta)<0 THEN
    raise EConvertError.Create('before 1970/01/01');
  // (ft-('1601/01/011970/01/01܂ł̍'))/10000000;
  asm
    mov  eax,ft.dwLowDateTime
    mov  edx,ft.dwHighDateTime
    mov  ecx,10000000
    sub  eax,$D53E8000
    sbb  edx,$19DB1DE
    div  ecx              // 40 clock ...
    mov  u,eax            // ]͖
  end;
  result:=u;
end;

//
//  UTC <-> DATETIME(localRo[g)
//
function Time_TtoDATETIME(utc:TTime_t):TDateTime;
begin
  result:=FileTimeToDateTime(Time_TtoFileTime(utc));
end;

function DateTimeToTime_T(dt:TDateTime):TTime_t;
begin
  result:=FileTimeToTime_T(DateTimeToFileTime(dt));
end;

//
// FileTime <-> DateTime(localRo[g)
//
function FileTimeToDateTime(ft:TFileTime):TDateTime;
var
  lft : TFileTime;
  st  : TSystemTime;
  dwork,twork : TDateTime;
begin
  IF (ft.dwLowDateTime=0) AND (ft.dwHighDateTime=0) THEN
    raise EConvertError.Create('ERR:value=0');
  IF NOT FileTimeToLocalFileTime(ft,lft) THEN
    raise EConvertError.Create('ERR:FileTimeToLocalFileTime');
  IF NOT FileTimeToSystemTime(lft,st) THEN
    raise EConvertError.Create('ERR:FileTimeToSystemTime');
  WITH st DO BEGIN
    dwork:=EncodeDate(wYear,wMonth,wDay);
    twork:=EncodeTime(wHour,wMinute,wSecond,wMilliseconds);
  END;
  result:=dwork+twork;
end;

function DateTimeToFileTime(dt:TDateTime):TFileTime;
var
  lft,ft : TFileTime;
  st     : TSystemTime;
begin
  IF dt<=0.0 THEN
    raise EConvertError.Create('ERR:TDateTime<=0.0');
  WITH st DO BEGIN
    DecodeDate(dt,wYear,wMonth,wDay);
    DecodeTime(dt,wHour,wMinute,wSecond,wMilliseconds);
  END;
  IF NOT SystemTimeToFileTime(st,lft) THEN
    raise EConvertError.Create('ERR:SystemTimeToFileTime');
  IF NOT LocalFileTimeToFileTime(lft,ft) THEN
    raise EConvertError.Create('ERR:LocalTimeToFileTime');
  result:=ft;
end;

function FileTimeToDateTime2(ft:TFileTime; ADefault:TDateTime):TDateTime;
var
  lft : TFileTime;
  st  : TSystemTime;
  dwork,twork : TDateTime;
begin
  result:=ADefault;
  IF (ft.dwLowDateTime=0) AND (ft.dwHighDateTime=0) THEN Exit;
  IF NOT FileTimeToLocalFileTime(ft,lft) THEN Exit;
  IF NOT FileTimeToSystemTime(lft,st) THEN Exit;
  WITH st DO BEGIN
    dwork:=EncodeDate(wYear,wMonth,wDay);
    twork:=EncodeTime(wHour,wMinute,wSecond,wMilliseconds);
  END;
  result:=dwork+twork;
end;

function DateTimeToFileTime2(dt:TDateTime; ADefault:TFileTime):TFileTime;
var
  lft,ft : TFileTime;
  st     : TSystemTime;
begin
  result:=ADefault;
  IF dt<=0.0 THEN Exit;
  WITH st DO BEGIN
    DecodeDate(dt,wYear,wMonth,wDay);
    DecodeTime(dt,wHour,wMinute,wSecond,wMilliseconds);
  END;
  IF NOT SystemTimeToFileTime(st,lft) THEN Exit;
  IF NOT LocalFileTimeToFileTime(lft,ft) THEN Exit;
  result:=ft;
end;

//
// LocalTime <-> DateTime
//
function LocalTimeToDateTime(lt:TFileTime):TDateTime;
var
  st  : TSystemTime;
  dwork,twork : TDateTime;
begin
  IF (lt.dwLowDateTime=0) AND (lt.dwHighDateTime=0) THEN
    raise EConvertError.Create('ERR:value=0');
  IF NOT FileTimeToSystemTime(lt,st) THEN
    raise EConvertError.Create('ERR:FileTimeToSystemTime');
  WITH st DO BEGIN
    dwork:=EncodeDate(wYear,wMonth,wDay);
    twork:=EncodeTime(wHour,wMinute,wSecond,wMilliseconds);
  END;
  result:=dwork+twork;
end;

function DateTimeToLocalTime(dt:TDateTime):TFileTime;
var
  lt : TFileTime;
  st : TSystemTime;
begin
  IF dt<=0.0 THEN
    raise EConvertError.Create('ERR:TDateTime<=0.0');
  WITH st DO BEGIN
    DecodeDate(dt,wYear,wMonth,wDay);
    DecodeTime(dt,wHour,wMinute,wSecond,wMilliseconds);
  END;
  IF NOT SystemTimeToFileTime(st,lt) THEN
    raise EConvertError.Create('ERR:SystemTimeToFileTime');
  result:=lt;
end;

//
// DateTime -> DosTime
//
function DateTimeToDosTime(dt:TDateTime):TDateTime;
var
  Year, Month, Day, Hour, Min, Sec, MSec: Word;
begin
  DecodeDate(dt, Year, Month, Day);
  //if (Year < 1980) or (Year > 2079) then Result := 0 else
  IF Year < 1980 THEN raise EConvertError.Create('before 1980');
  IF Year > 2079 THEN raise EConvertError.Create('after 2079');
  begin
    DecodeTime(dt, Hour, Min, Sec, MSec);
    // 炪DateTimeToFileDateƈႤ
    IF (msec>0) OR Odd(sec) THEN BEGIN
      IF Msec>0 THEN BEGIN
        Msec:=1000-MSec; INC(sec);
      END;
      IF Odd(Sec) THEN Sec:=1 ELSE Sec:=0;
      result:=dt+EncodeTime(0,0,Sec,MSec);
    END ELSE
      result:=dt;
  end;
end;

function DateTimeToDosTime2(dt:TDateTime; ADefault:TDateTime):TDateTime;
var
  Year, Month, Day, Hour, Min, Sec, MSec: Word;
begin
  result:=ADefault;
  DecodeDate(dt, Year, Month, Day);
  //if (Year < 1980) or (Year > 2079) then Result := 0 else
  IF Year < 1980 THEN Exit;
  IF Year > 2079 THEN Exit;
  DecodeTime(dt, Hour, Min, Sec, MSec);
  // 炪DateTimeToFileDateƈႤ
  IF (msec>0) OR Odd(sec) THEN BEGIN
    IF Msec>0 THEN BEGIN
      Msec:=1000-MSec; INC(sec);
    END;
    IF Odd(Sec) THEN Sec:=1 ELSE Sec:=0;
    result:=dt+EncodeTime(0,0,Sec,MSec);
  END ELSE
    result:=dt;
end;

end.
